/*
 * Copyright (c) 1998-2008 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */
package com.teamdev.xpcom.mozilla.demo;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

import org.jdesktop.layout.GroupLayout;

@SuppressWarnings("serial")
class TitledPane extends JPanel
{
    protected JLabel _title;

    protected JLabel _closeIcon;

    private Action _closeAction;

    public TitledPane()
    {
        setLayout(new BorderLayout());

        _closeIcon = new JLabel();
        final Cursor handCursor = new Cursor(Cursor.HAND_CURSOR);
        _closeIcon.setCursor(handCursor);
        _closeIcon.setIcon(new ImageIcon(this.getClass().getResource("res/Close.gif")));
        _closeIcon.setToolTipText("Close");
        final Border emptyBorder = BorderFactory.createEmptyBorder(1, 2, 1, 2);
        final Border etchedBorder = BorderFactory.createEtchedBorder();
        _closeIcon.setBorder(emptyBorder);
        _closeIcon.addMouseListener(new MouseAdapter()
        {
            public void mouseEntered(MouseEvent e)
            {
                _closeIcon.setBorder(etchedBorder);
            }

            public void mouseExited(MouseEvent e)
            {
                _closeIcon.setBorder(emptyBorder);
            }

            public void mouseClicked(MouseEvent event)
            {
                if (event.getButton() == MouseEvent.BUTTON1)
                {
                    _closeAction.actionPerformed(null);
                }
            }
        });
                                       
        _title = new JLabel("");
        _title.setFocusable(false);
        _title.setBorder(null);

        final JPanel titlePanel = new JPanel();
		GroupLayout titlePanelLayout = new GroupLayout(titlePanel);
		titlePanel.setLayout(titlePanelLayout);
		titlePanelLayout.setHorizontalGroup(titlePanelLayout.createSequentialGroup()
            .add(5, 5, 5)
            .add(_title, 5, 5, 10000)
            .add(5, 5, 5)
            .add(_closeIcon)
            .add(2, 2, 2)
        );
		titlePanelLayout.setVerticalGroup(titlePanelLayout.createParallelGroup()
            .add(_title)
            .add(_closeIcon)
        );

        add(titlePanel, BorderLayout.NORTH);
    }

    public void setTitle(String value)
    {
        _title.setText(value);
    }

    public void setComponent(JComponent component)
    {
        add(component, BorderLayout.CENTER);
    }

    public void assignCloseAction(final Action closeAction)
    {
        this._closeAction = closeAction;
    }
}
